import * as i0 from '@angular/core';
import { inject, Component, ChangeDetectionStrategy } from '@angular/core';
import { RxIf } from '@rx-angular/template/if';
import { RxLet } from '@rx-angular/template/let';
import { RxPush } from '@rx-angular/template/push';
import { BaseWidgetComponent, FormService, WidgetRegistry, WidgetRendererComponent } from '@smallstack/widget-core';
import { filterNullish } from '@smallstack/utils';
import { switchMap, of, map } from 'rxjs';

class FilterFieldWidgetComponent extends BaseWidgetComponent {
    constructor() {
        super(...arguments);
        this.formService = inject(FormService);
        this.widgetRegistry = inject(WidgetRegistry);
        this.widgetName$ = this.data$.pipe(filterNullish(), switchMap((data) => {
            if (data.filterSchema) {
                return of(this.widgetRegistry.getFilterWidgetBySchema(data.filterSchema));
            }
            else
                return this.formService
                    .getSchemaForPath$(data.path)
                    .pipe(map((schema) => this.widgetRegistry.getFilterWidgetBySchema(schema)));
        }), filterNullish(), map((widgetRegistryEntry) => widgetRegistryEntry.name));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: FilterFieldWidgetComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: FilterFieldWidgetComponent, isStandalone: true, selector: "smallstack-filter-field-widget", usesInheritance: true, ngImport: i0, template: "<ng-container *rxLet=\"widgetName$; let widgetName\">\n  <smallstack-widget-renderer\n    *rxIf=\"widgetName; else noWidget\"\n    [widget]=\"{ name: widgetName, data: data$ | push }\"\n  ></smallstack-widget-renderer>\n</ng-container>\n<ng-template #noWidget>\n  <div class=\"text-xs text-gray-500\">no suitable filter found</div>\n</ng-template>\n", dependencies: [{ kind: "pipe", type: RxPush, name: "push" }, { kind: "directive", type: RxIf, selector: "[rxIf]", inputs: ["rxIf", "rxIfStrategy", "rxIfElse", "rxIfThen", "rxIfSuspense", "rxIfComplete", "rxIfError", "rxIfContextTrigger", "rxIfNextTrigger", "rxIfSuspenseTrigger", "rxIfErrorTrigger", "rxIfCompleteTrigger", "rxIfParent", "rxIfPatchZone", "rxIfRenderCallback"] }, { kind: "directive", type: RxLet, selector: "[rxLet]", inputs: ["rxLet", "rxLetStrategy", "rxLetComplete", "rxLetError", "rxLetSuspense", "rxLetContextTrigger", "rxLetCompleteTrigger", "rxLetErrorTrigger", "rxLetSuspenseTrigger", "rxLetNextTrigger", "rxLetRenderCallback", "rxLetParent", "rxLetPatchZone"], outputs: ["rendered"] }, { kind: "component", type: WidgetRendererComponent, selector: "smallstack-widget-renderer", inputs: ["widget", "additionalProviders", "context", "class"], outputs: ["widgetChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: FilterFieldWidgetComponent, decorators: [{
            type: Component,
            args: [{ selector: "smallstack-filter-field-widget", standalone: true, imports: [RxPush, RxIf, RxLet, WidgetRendererComponent], changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *rxLet=\"widgetName$; let widgetName\">\n  <smallstack-widget-renderer\n    *rxIf=\"widgetName; else noWidget\"\n    [widget]=\"{ name: widgetName, data: data$ | push }\"\n  ></smallstack-widget-renderer>\n</ng-container>\n<ng-template #noWidget>\n  <div class=\"text-xs text-gray-500\">no suitable filter found</div>\n</ng-template>\n" }]
        }] });

export { FilterFieldWidgetComponent };
//# sourceMappingURL=smallstack-form-widgets-filter-field-widget.component-5e35705b.mjs.map
