import { SocketDtoDirectionEnum, SocketDtoTypeEnum } from '@smallstack/axios-api-client';
import { WIDGET_FORM_INPUT_BOOLEAN, WIDGET_FORM_INPUT_CUSTOM_FIELDS, WIDGET_FORM_INPUT_I18N, WIDGET_FORM_INPUT_MANGO_QUERY, WIDGET_FILTER_INPUT_NUMBER, WIDGET_FORM_INPUT_NUMBER, WIDGET_FILTER_INPUT_SELECT, WIDGET_FORM_INPUT_SELECT, WIDGET_FORM_INPUT_STRING } from '@smallstack/core-common';

var CONFIGURATION_KEYS$1;
(function (CONFIGURATION_KEYS) {
    CONFIGURATION_KEYS["GLOBAL_VARIABLE_NAME"] = "globalVariableName";
    CONFIGURATION_KEYS["ARRAY_SCHEMA"] = "arraySchema";
})(CONFIGURATION_KEYS$1 || (CONFIGURATION_KEYS$1 = {}));
var SOCKETS$1;
(function (SOCKETS) {
    SOCKETS["VALUE"] = "value";
})(SOCKETS$1 || (SOCKETS$1 = {}));
const AddToArrayFormWidget = {
    name: "AddToArrayForm",
    configuration: {
        templateName: "Add to Array Form",
        templateDescription: "Ein Widget, welches ein Formular anzeigt, um ein Element zu einem Array hinzuzufügen, welches sich in einem Objekt auf dem aktuellen Kontext befindet.",
        icon: "add",
        dataSchema: {
            type: "object",
            properties: {
                [CONFIGURATION_KEYS$1.GLOBAL_VARIABLE_NAME]: {
                    type: "string",
                    title: "Globale Variable Name",
                    description: "Der Name der Variable, welche das Array enthält, welches erweitert werden soll."
                },
                [CONFIGURATION_KEYS$1.ARRAY_SCHEMA]: {
                    type: "string",
                    title: "Formular Schema",
                    description: "Das Schema des Formulars, welches das neue Element beschreibt.",
                    "x-schema-form": {
                        widget: "monaco",
                        monacoLanguage: "json"
                    }
                }
            }
        },
        sockets: [{ direction: SocketDtoDirectionEnum.Out, name: SOCKETS$1.VALUE, type: SocketDtoTypeEnum.Object }]
    },
    component: () => import('./smallstack-form-widgets-add-to-array-form-widget.component-568ba3f8.mjs').then((m) => m.AddToArrayFormWidgetComponent)
};

const BooleanInputWidget = {
    name: WIDGET_FORM_INPUT_BOOLEAN,
    component: () => import('./smallstack-form-widgets-boolean-input-widget.component-9b57a4ef.mjs').then((m) => m.BooleanInputWidgetComponent),
    configuration: {
        templateName: "Boolean Feld",
        templateDescription: "Zeigt ein ja/nein bzw. wahr/falsch Feld an.",
        icon: "checked-checkbox"
    }
};

const CustomFieldsInputWidget = {
    name: WIDGET_FORM_INPUT_CUSTOM_FIELDS,
    component: () => import('./smallstack-form-widgets-custom-fields-input-widget.component-7f27a006.mjs').then((m) => m.CustomFieldsInputWidgetComponent)
};

const DateFilterWidget = {
    name: "DateFilter",
    component: () => import('./smallstack-form-widgets-date-filter-widget.component-811eeac6.mjs').then((m) => m.DateFilterWidgetComponent),
    configuration: {
        templateName: "Datum Filter",
        templateDescription: "Zeigt Felder an, welche zum Filtern von einem Datum verwendet werden können.",
        icon: "filter"
    }
};

const FilterFieldWidget = {
    name: "FilterField",
    component: () => import('./smallstack-form-widgets-filter-field-widget.component-5e35705b.mjs').then((m) => m.FilterFieldWidgetComponent),
    configuration: {
        templateName: "Filter",
        templateDescription: "Zeigt ein passendes Feld an, welches zum Filtern verwendet werden kann.",
        icon: "filter"
    }
};

const I18nFilterWidget = {
    name: "I18nFilter",
    component: () => import('./smallstack-form-widgets-i18n-filter-widget.component-aba46b69.mjs').then((m) => m.I18nFilterWidgetComponent),
    configuration: {
        templateName: "Übersetzungen Filter",
        templateDescription: "Zeigt ein Feld an, welches zum Filtern von Übersetzungen verwendet werden kann.",
        icon: "filter"
    }
};

const I18nInputWidget = {
    name: WIDGET_FORM_INPUT_I18N,
    component: () => import('./smallstack-form-widgets-i18n-input-widget.component-27a9a4f6.mjs').then((m) => m.I18nInputWidgetComponent)
};

const MangoQueryInputWidget = {
    name: WIDGET_FORM_INPUT_MANGO_QUERY,
    component: () => import('./smallstack-form-widgets-mango-query-input-widget.component-9ba1a4be.mjs').then((m) => m.MangoQueryInputWidgetComponent),
    configuration: {
        templateName: "Datenbank Filter Feld",
        templateDescription: "Mit diesen Feldern kann eine Datenbank Abfrage erstellt werden.",
        icon: "database"
    }
};

const NumberFilterWidget = {
    name: WIDGET_FILTER_INPUT_NUMBER,
    component: () => import('./smallstack-form-widgets-number-filter-widget.component-d4470b18.mjs').then((m) => m.NumberFilterWidgetComponent),
    configuration: {
        templateName: "Nummern Filter",
        templateDescription: "Filtert nach einer Zahl",
        icon: "filter"
    }
};

const NumberInputWidget = {
    name: WIDGET_FORM_INPUT_NUMBER,
    component: () => import('./smallstack-form-widgets-number-input-widget.component-1350a371.mjs').then((m) => m.NumberInputWidgetComponent),
    configuration: {
        templateName: "Nummern Feld",
        templateDescription: "Zeigt ein Feld in welches eine Nummer eingegeben werden kann.",
        icon: "rename"
    }
};

const ObjectFilterWidget = {
    name: "ObjectFilter",
    component: () => import('./smallstack-form-widgets-object-filter-widget.component-ba3c6397.mjs').then((m) => m.ObjectFilterWidgetComponent),
    configuration: {
        templateName: "Objekt Filter",
        templateDescription: "Zeigt Filter für alle Eigenschaften des Objektes an.",
        icon: "filter"
    }
};

var CONFIGURATION_KEYS;
(function (CONFIGURATION_KEYS) {
    CONFIGURATION_KEYS["GLOBAL_VARIABLE_NAME"] = "globalVariableName";
    CONFIGURATION_KEYS["TYPE_PATH"] = "typePath";
    CONFIGURATION_KEYS["BTN_TEXT"] = "btnText";
})(CONFIGURATION_KEYS || (CONFIGURATION_KEYS = {}));
var SOCKETS;
(function (SOCKETS) {
    SOCKETS["SAVED_SUCCESSFULLY"] = "savedSuccessfully";
})(SOCKETS || (SOCKETS = {}));
const SaveModelBtnWidget = {
    name: "SaveModelBtn",
    configuration: {
        templateName: "Entität Speichern Button",
        templateDescription: "Ein Widget, welches einen Button anzeigt, um eine Entität zu speichern.",
        icon: "save--v1",
        dataSchema: {
            type: "object",
            properties: {
                [CONFIGURATION_KEYS.TYPE_PATH]: {
                    type: "string",
                    title: "Datentyp",
                    "x-schema-form": {
                        widget: "types"
                    }
                },
                [CONFIGURATION_KEYS.GLOBAL_VARIABLE_NAME]: {
                    type: "string",
                    title: "Variable Name",
                    description: "Der Name der Variable, welche das Array enthält, welches erweitert werden soll."
                },
                [CONFIGURATION_KEYS.BTN_TEXT]: {
                    type: "string",
                    title: "Button Text",
                    description: "Der Text, welcher auf dem Button angezeigt werden soll.",
                    default: "Speichern"
                }
            }
        },
        sockets: [
            { direction: SocketDtoDirectionEnum.Out, name: SOCKETS.SAVED_SUCCESSFULLY, type: SocketDtoTypeEnum.Boolean }
        ]
    },
    component: () => import('./smallstack-form-widgets-save-model-btn-widget.component-4ba54fbc.mjs').then((m) => m.SaveModelBtnWidgetComponent)
};

const SelectFilterWidget = {
    name: WIDGET_FILTER_INPUT_SELECT,
    component: () => import('./smallstack-form-widgets-select-filter-widget.component-fe4c7af4.mjs').then((m) => m.SelectFilterWidgetComponent),
    configuration: {
        templateName: "Auswahl Filter",
        templateDescription: "Filtert nach Auswahl verschiedener Werte",
        icon: "filter"
    }
};

const SelectInputWidget = {
    name: WIDGET_FORM_INPUT_SELECT,
    component: () => import('./smallstack-form-widgets-select-input-widget.component-62e8d411.mjs').then((m) => m.SelectInputWidgetComponent)
};

const StringFilterWidget = {
    name: "StringFilter",
    component: () => import('./smallstack-form-widgets-string-filter-widget.component-14c81961.mjs').then((m) => m.StringFilterWidgetComponent),
    configuration: {
        templateName: "String Filter",
        templateDescription: "Zeigt ein Feld an, welches zum Filtern von Zeichenketten verwendet werden kann.",
        icon: "filter"
    }
};

const StringInputWidget = {
    name: WIDGET_FORM_INPUT_STRING,
    component: () => import('./smallstack-form-widgets-string-input-widget.component-50cebe80.mjs').then((m) => m.StringInputWidgetComponent),
    configuration: {
        templateName: "Zeichenketten Feld",
        templateDescription: "Zeigt ein Feld in welches eine Zeichenkette eingegeben werden kann.",
        icon: "rename"
    }
};

const ArrayFilterWidget = {
    name: "ArrayFilter",
    component: () => import('./smallstack-form-widgets-array-filter-widget.component-7967b415.mjs').then((m) => m.ArrayFilterWidgetComponent),
    configuration: {
        templateName: "Objekt Filter",
        templateDescription: "Zeigt Filter für alle Eigenschaften des Objektes an.",
        icon: "filter"
    }
};

function addFormWidgets(widgetRegistry) {
    widgetRegistry.addWidget(AddToArrayFormWidget);
    widgetRegistry.addWidget(ArrayFilterWidget);
    widgetRegistry.addWidget(BooleanInputWidget);
    widgetRegistry.addWidget(CustomFieldsInputWidget);
    widgetRegistry.addWidget(DateFilterWidget);
    widgetRegistry.addWidget(FilterFieldWidget);
    widgetRegistry.addWidget(I18nFilterWidget);
    widgetRegistry.addWidget(I18nInputWidget);
    widgetRegistry.addWidget(MangoQueryInputWidget);
    widgetRegistry.addWidget(NumberFilterWidget);
    widgetRegistry.addWidget(NumberInputWidget);
    widgetRegistry.addWidget(ObjectFilterWidget);
    widgetRegistry.addWidget(SaveModelBtnWidget);
    widgetRegistry.addWidget(SelectFilterWidget);
    widgetRegistry.addWidget(SelectInputWidget);
    widgetRegistry.addWidget(StringFilterWidget);
    widgetRegistry.addWidget(StringInputWidget);
}

/**
 * Generated bundle index. Do not edit.
 */

export { CONFIGURATION_KEYS$1 as C, SOCKETS$1 as S, CONFIGURATION_KEYS as a, SOCKETS as b, addFormWidgets as c };
//# sourceMappingURL=smallstack-form-widgets-smallstack-form-widgets-26b1ef70.mjs.map
