import { NgClass } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import * as i1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import { RxLet } from '@rx-angular/template/let';
import { RxPush } from '@rx-angular/template/push';
import { filterNullish } from '@smallstack/utils';
import { FormInputContainerComponent } from '@smallstack/widget-core';
import { map } from 'rxjs';
import { I as InputBaseWidgetComponent } from './smallstack-form-widgets-input-base-widget.component-e4949b87.mjs';
import '@smallstack/i18n-components';

class StringInputWidgetComponent extends InputBaseWidgetComponent {
    constructor() {
        super(...arguments);
        this.type$ = this.schema$.pipe(filterNullish({ filterEmptyObjects: true }), map((schema) => {
            switch (schema.format) {
                case "password":
                    return "password";
                case "email":
                    return "email";
                default:
                    return "text";
            }
        }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: StringInputWidgetComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: StringInputWidgetComponent, isStandalone: true, selector: "smallstack-string-input-widget", usesInheritance: true, ngImport: i0, template: "<smallstack-form-input-container\n  [options]=\"options$ | push\"\n  [schema]=\"schema$ | push\"\n  [path]=\"path$ | push\"\n  [validationErrorText$]=\"validationErrorText$\"\n>\n  <input\n    [type]=\"type$ | push\"\n    class=\"input input-bordered w-full\"\n    [required]=\"required$ | push\"\n    [ngModel]=\"value$ | push\"\n    (ngModelChange)=\"setValue($event); validateOnChange()\"\n    (blur)=\"validateOnBlur()\"\n    [placeholder]=\"placeholder$ | push\"\n    data-test=\"schema-form-widget-input\"\n    (keyup.enter)=\"formService.submit()\"\n    [ngClass]=\"{ 'input-error': (validationErrorText$ | push) !== undefined }\"\n  />\n</smallstack-form-input-container>\n", dependencies: [{ kind: "pipe", type: RxPush, name: "push" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: FormInputContainerComponent, selector: "smallstack-form-input-container", inputs: ["validationErrorText$", "options", "schema", "path"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: StringInputWidgetComponent, decorators: [{
            type: Component,
            args: [{ selector: "smallstack-string-input-widget", standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, imports: [RxPush, RxLet, FormsModule, FormInputContainerComponent, NgClass], template: "<smallstack-form-input-container\n  [options]=\"options$ | push\"\n  [schema]=\"schema$ | push\"\n  [path]=\"path$ | push\"\n  [validationErrorText$]=\"validationErrorText$\"\n>\n  <input\n    [type]=\"type$ | push\"\n    class=\"input input-bordered w-full\"\n    [required]=\"required$ | push\"\n    [ngModel]=\"value$ | push\"\n    (ngModelChange)=\"setValue($event); validateOnChange()\"\n    (blur)=\"validateOnBlur()\"\n    [placeholder]=\"placeholder$ | push\"\n    data-test=\"schema-form-widget-input\"\n    (keyup.enter)=\"formService.submit()\"\n    [ngClass]=\"{ 'input-error': (validationErrorText$ | push) !== undefined }\"\n  />\n</smallstack-form-input-container>\n" }]
        }] });

export { StringInputWidgetComponent };
//# sourceMappingURL=smallstack-form-widgets-string-input-widget.component-50cebe80.mjs.map
