import { TranslationStore } from "@smallstack/i18n-components";
import { SmallstackTypeSchema } from "@smallstack/typesystem";
import { BaseWidgetComponent, FormService, InputWidgetValidationError } from "@smallstack/widget-core";
import { Observable } from "rxjs";
import * as i0 from "@angular/core";
export declare abstract class InputBaseWidgetComponent<TYPE = any> extends BaseWidgetComponent {
    protected formService: FormService;
    protected translationStore: TranslationStore;
    protected path$: Observable<any>;
    protected schema$: Observable<SmallstackTypeSchema>;
    /** value of the form field */
    protected value$: Observable<TYPE>;
    protected required$: Observable<boolean>;
    protected placeholder$: Observable<string>;
    protected validationErrors$: Observable<InputWidgetValidationError[]>;
    protected validationErrorText$: Observable<string>;
    protected options$: Observable<any>;
    protected setValue(value: TYPE): Promise<void>;
    /** Triggers the validation for this input widget if options.validateOn === "onBlur" */
    protected validateOnBlur(): Promise<void>;
    /** Triggers the validation for this input widget if options.validateOn === "onBlur" */
    protected validateOnChange(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<InputBaseWidgetComponent<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<InputBaseWidgetComponent<any>, never, never, {}, {}, never, never, false, never>;
}
